/*
 * このソースコードは blanco Frameworkによって自動生成されています。
 */
package blanco.db.stringgroup;

/**
 * そのままblancoDbのバリューオブジェクトの列名になると困る文字列を定義します。該当するとF_を付与します。文字列定義の際にはアンダーバーは除いた形で登録を行います。
 */
public class BlancoDbDotNetSpecialStringGroup {
    /**
     * No.1 説明:GetTypeに展開されて困ります。
     */
    public static final int TYPE = 1;

    /**
     * No.2 説明:GetHashCodeに展開されて困ります。
     */
    public static final int HASHCODE = 2;

    /**
     * No.3 説明:GetTypeCodeに展開されて困ります。
     */
    public static final int TYPECODE = 3;

    /**
     * No.4 説明:GetCustomAttributeに展開されて困ります。
     */
    public static final int CUSTOMATTRIBUTE = 4;

    /**
     * No.5 説明:GetCustomAttributesに展開されて困ります。
     */
    public static final int CUSTOMATTRIBUTES = 5;

    /**
     * 未定義。文字列グループ以外の文字列または定数が未定義のもの。
     */
    public static final int NOT_DEFINED = -1;

    /**
     * 文字列グループに含まれる文字列であるかどうかを判定します。
     *
     * @param argCheck チェックを行いたい文字列。
     * @return 文字列グループに含まれていればture。グループに含まれない文字列であればfalse。
     */
    public boolean match(final String argCheck) {
        // No.1
        // 説明:GetTypeに展開されて困ります。
        if ("TYPE".equals(argCheck)) {
            return true;
        }
        // No.2
        // 説明:GetHashCodeに展開されて困ります。
        if ("HASHCODE".equals(argCheck)) {
            return true;
        }
        // No.3
        // 説明:GetTypeCodeに展開されて困ります。
        if ("TYPECODE".equals(argCheck)) {
            return true;
        }
        // No.4
        // 説明:GetCustomAttributeに展開されて困ります。
        if ("CUSTOMATTRIBUTE".equals(argCheck)) {
            return true;
        }
        // No.5
        // 説明:GetCustomAttributesに展開されて困ります。
        if ("CUSTOMATTRIBUTES".equals(argCheck)) {
            return true;
        }
        return false;
    }

    /**
     * 文字列グループに含まれる文字列であるかどうかを、大文字小文字を区別せず判定します。
     *
     * @param argCheck チェックを行いたい文字列。
     * @return 文字列グループに含まれていればture。グループに含まれない文字列であればfalse。
     */
    public boolean matchIgnoreCase(final String argCheck) {
        // No.1
        // 説明:GetTypeに展開されて困ります。
        if ("TYPE".equalsIgnoreCase(argCheck)) {
            return true;
        }
        // No.2
        // 説明:GetHashCodeに展開されて困ります。
        if ("HASHCODE".equalsIgnoreCase(argCheck)) {
            return true;
        }
        // No.3
        // 説明:GetTypeCodeに展開されて困ります。
        if ("TYPECODE".equalsIgnoreCase(argCheck)) {
            return true;
        }
        // No.4
        // 説明:GetCustomAttributeに展開されて困ります。
        if ("CUSTOMATTRIBUTE".equalsIgnoreCase(argCheck)) {
            return true;
        }
        // No.5
        // 説明:GetCustomAttributesに展開されて困ります。
        if ("CUSTOMATTRIBUTES".equalsIgnoreCase(argCheck)) {
            return true;
        }
        return false;
    }

    /**
     * 文字列から定数に変換します。
     *
     * 定数が未定義の場合や 与えられた文字列が文字列グループ外の場合には NOT_DEFINED を戻します。
     *
     * @param argCheck 変換を行いたい文字列。
     * @return 定数に変換後の値。
     */
    public int convertToInt(final String argCheck) {
        // No.1
        // 説明:GetTypeに展開されて困ります。
        if ("TYPE".equals(argCheck)) {
            return TYPE;
        }
        // No.2
        // 説明:GetHashCodeに展開されて困ります。
        if ("HASHCODE".equals(argCheck)) {
            return HASHCODE;
        }
        // No.3
        // 説明:GetTypeCodeに展開されて困ります。
        if ("TYPECODE".equals(argCheck)) {
            return TYPECODE;
        }
        // No.4
        // 説明:GetCustomAttributeに展開されて困ります。
        if ("CUSTOMATTRIBUTE".equals(argCheck)) {
            return CUSTOMATTRIBUTE;
        }
        // No.5
        // 説明:GetCustomAttributesに展開されて困ります。
        if ("CUSTOMATTRIBUTES".equals(argCheck)) {
            return CUSTOMATTRIBUTES;
        }

        // 該当する定数が見つかりませんでした。
        return NOT_DEFINED;
    }

    /**
     * 定数から文字列に変換します。
     *
     * 定数と対応づく文字列に変換します。
     *
     * @param argCheck 変換を行いたい文字定数。
     * @return 文字列に変換後の値。NOT_DEFINEDの場合には長さ0の文字列。
     */
    public String convertToString(final int argCheck) {
        // No.1
        // 説明:GetTypeに展開されて困ります。
        if (argCheck == TYPE) {
            return "TYPE";
        }
        // No.2
        // 説明:GetHashCodeに展開されて困ります。
        if (argCheck == HASHCODE) {
            return "HASHCODE";
        }
        // No.3
        // 説明:GetTypeCodeに展開されて困ります。
        if (argCheck == TYPECODE) {
            return "TYPECODE";
        }
        // No.4
        // 説明:GetCustomAttributeに展開されて困ります。
        if (argCheck == CUSTOMATTRIBUTE) {
            return "CUSTOMATTRIBUTE";
        }
        // No.5
        // 説明:GetCustomAttributesに展開されて困ります。
        if (argCheck == CUSTOMATTRIBUTES) {
            return "CUSTOMATTRIBUTES";
        }
        // 未定義。
        if (argCheck == NOT_DEFINED) {
            return "";
        }

        // いずれにも該当しませんでした。
        throw new IllegalArgumentException("与えられた値(" + argCheck + ")は文字列グループ[BlancoDbDotNetSpecial]では定義されない値です。");
    }
}
